// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from vrxperience_msgs:msg/CabToSteeringCorrective.idl
// generated code does not contain a copyright notice

#ifndef VRXPERIENCE_MSGS__MSG__DETAIL__CAB_TO_STEERING_CORRECTIVE__STRUCT_HPP_
#define VRXPERIENCE_MSGS__MSG__DETAIL__CAB_TO_STEERING_CORRECTIVE__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__vrxperience_msgs__msg__CabToSteeringCorrective __attribute__((deprecated))
#else
# define DEPRECATED__vrxperience_msgs__msg__CabToSteeringCorrective __declspec(deprecated)
#endif

namespace vrxperience_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct CabToSteeringCorrective_
{
  using Type = CabToSteeringCorrective_<ContainerAllocator>;

  explicit CabToSteeringCorrective_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->additive_steering_wheel_angle = 0.0;
      this->multiplicative_steering_wheel_angle = 0.0;
      this->additive_steering_wheel_speed = 0.0;
      this->multiplicative_steering_wheel_speed = 0.0;
      this->additive_steering_wheel_accel = 0.0;
      this->multiplicative_steering_wheel_accel = 0.0;
      this->additive_steering_wheel_torque = 0.0;
      this->multiplicative_steering_wheel_torque = 0.0;
    }
  }

  explicit CabToSteeringCorrective_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->additive_steering_wheel_angle = 0.0;
      this->multiplicative_steering_wheel_angle = 0.0;
      this->additive_steering_wheel_speed = 0.0;
      this->multiplicative_steering_wheel_speed = 0.0;
      this->additive_steering_wheel_accel = 0.0;
      this->multiplicative_steering_wheel_accel = 0.0;
      this->additive_steering_wheel_torque = 0.0;
      this->multiplicative_steering_wheel_torque = 0.0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _additive_steering_wheel_angle_type =
    double;
  _additive_steering_wheel_angle_type additive_steering_wheel_angle;
  using _multiplicative_steering_wheel_angle_type =
    double;
  _multiplicative_steering_wheel_angle_type multiplicative_steering_wheel_angle;
  using _additive_steering_wheel_speed_type =
    double;
  _additive_steering_wheel_speed_type additive_steering_wheel_speed;
  using _multiplicative_steering_wheel_speed_type =
    double;
  _multiplicative_steering_wheel_speed_type multiplicative_steering_wheel_speed;
  using _additive_steering_wheel_accel_type =
    double;
  _additive_steering_wheel_accel_type additive_steering_wheel_accel;
  using _multiplicative_steering_wheel_accel_type =
    double;
  _multiplicative_steering_wheel_accel_type multiplicative_steering_wheel_accel;
  using _additive_steering_wheel_torque_type =
    double;
  _additive_steering_wheel_torque_type additive_steering_wheel_torque;
  using _multiplicative_steering_wheel_torque_type =
    double;
  _multiplicative_steering_wheel_torque_type multiplicative_steering_wheel_torque;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__additive_steering_wheel_angle(
    const double & _arg)
  {
    this->additive_steering_wheel_angle = _arg;
    return *this;
  }
  Type & set__multiplicative_steering_wheel_angle(
    const double & _arg)
  {
    this->multiplicative_steering_wheel_angle = _arg;
    return *this;
  }
  Type & set__additive_steering_wheel_speed(
    const double & _arg)
  {
    this->additive_steering_wheel_speed = _arg;
    return *this;
  }
  Type & set__multiplicative_steering_wheel_speed(
    const double & _arg)
  {
    this->multiplicative_steering_wheel_speed = _arg;
    return *this;
  }
  Type & set__additive_steering_wheel_accel(
    const double & _arg)
  {
    this->additive_steering_wheel_accel = _arg;
    return *this;
  }
  Type & set__multiplicative_steering_wheel_accel(
    const double & _arg)
  {
    this->multiplicative_steering_wheel_accel = _arg;
    return *this;
  }
  Type & set__additive_steering_wheel_torque(
    const double & _arg)
  {
    this->additive_steering_wheel_torque = _arg;
    return *this;
  }
  Type & set__multiplicative_steering_wheel_torque(
    const double & _arg)
  {
    this->multiplicative_steering_wheel_torque = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    vrxperience_msgs::msg::CabToSteeringCorrective_<ContainerAllocator> *;
  using ConstRawPtr =
    const vrxperience_msgs::msg::CabToSteeringCorrective_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<vrxperience_msgs::msg::CabToSteeringCorrective_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<vrxperience_msgs::msg::CabToSteeringCorrective_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      vrxperience_msgs::msg::CabToSteeringCorrective_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<vrxperience_msgs::msg::CabToSteeringCorrective_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      vrxperience_msgs::msg::CabToSteeringCorrective_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<vrxperience_msgs::msg::CabToSteeringCorrective_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<vrxperience_msgs::msg::CabToSteeringCorrective_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<vrxperience_msgs::msg::CabToSteeringCorrective_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__vrxperience_msgs__msg__CabToSteeringCorrective
    std::shared_ptr<vrxperience_msgs::msg::CabToSteeringCorrective_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__vrxperience_msgs__msg__CabToSteeringCorrective
    std::shared_ptr<vrxperience_msgs::msg::CabToSteeringCorrective_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CabToSteeringCorrective_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->additive_steering_wheel_angle != other.additive_steering_wheel_angle) {
      return false;
    }
    if (this->multiplicative_steering_wheel_angle != other.multiplicative_steering_wheel_angle) {
      return false;
    }
    if (this->additive_steering_wheel_speed != other.additive_steering_wheel_speed) {
      return false;
    }
    if (this->multiplicative_steering_wheel_speed != other.multiplicative_steering_wheel_speed) {
      return false;
    }
    if (this->additive_steering_wheel_accel != other.additive_steering_wheel_accel) {
      return false;
    }
    if (this->multiplicative_steering_wheel_accel != other.multiplicative_steering_wheel_accel) {
      return false;
    }
    if (this->additive_steering_wheel_torque != other.additive_steering_wheel_torque) {
      return false;
    }
    if (this->multiplicative_steering_wheel_torque != other.multiplicative_steering_wheel_torque) {
      return false;
    }
    return true;
  }
  bool operator!=(const CabToSteeringCorrective_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CabToSteeringCorrective_

// alias to use template instance with default allocator
using CabToSteeringCorrective =
  vrxperience_msgs::msg::CabToSteeringCorrective_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace vrxperience_msgs

#endif  // VRXPERIENCE_MSGS__MSG__DETAIL__CAB_TO_STEERING_CORRECTIVE__STRUCT_HPP_
