// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from vrxperience_msgs:msg/LaserMeterPoint.idl
// generated code does not contain a copyright notice
#include "vrxperience_msgs/msg/detail/laser_meter_point__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `intersection_point`
#include "geometry_msgs/msg/detail/point__functions.h"

bool
vrxperience_msgs__msg__LaserMeterPoint__init(vrxperience_msgs__msg__LaserMeterPoint * msg)
{
  if (!msg) {
    return false;
  }
  // hit
  // h_angle
  // v_angle
  // intersection_point
  if (!geometry_msgs__msg__Point__init(&msg->intersection_point)) {
    vrxperience_msgs__msg__LaserMeterPoint__fini(msg);
    return false;
  }
  // distance
  return true;
}

void
vrxperience_msgs__msg__LaserMeterPoint__fini(vrxperience_msgs__msg__LaserMeterPoint * msg)
{
  if (!msg) {
    return;
  }
  // hit
  // h_angle
  // v_angle
  // intersection_point
  geometry_msgs__msg__Point__fini(&msg->intersection_point);
  // distance
}

bool
vrxperience_msgs__msg__LaserMeterPoint__are_equal(const vrxperience_msgs__msg__LaserMeterPoint * lhs, const vrxperience_msgs__msg__LaserMeterPoint * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // hit
  if (lhs->hit != rhs->hit) {
    return false;
  }
  // h_angle
  if (lhs->h_angle != rhs->h_angle) {
    return false;
  }
  // v_angle
  if (lhs->v_angle != rhs->v_angle) {
    return false;
  }
  // intersection_point
  if (!geometry_msgs__msg__Point__are_equal(
      &(lhs->intersection_point), &(rhs->intersection_point)))
  {
    return false;
  }
  // distance
  if (lhs->distance != rhs->distance) {
    return false;
  }
  return true;
}

bool
vrxperience_msgs__msg__LaserMeterPoint__copy(
  const vrxperience_msgs__msg__LaserMeterPoint * input,
  vrxperience_msgs__msg__LaserMeterPoint * output)
{
  if (!input || !output) {
    return false;
  }
  // hit
  output->hit = input->hit;
  // h_angle
  output->h_angle = input->h_angle;
  // v_angle
  output->v_angle = input->v_angle;
  // intersection_point
  if (!geometry_msgs__msg__Point__copy(
      &(input->intersection_point), &(output->intersection_point)))
  {
    return false;
  }
  // distance
  output->distance = input->distance;
  return true;
}

vrxperience_msgs__msg__LaserMeterPoint *
vrxperience_msgs__msg__LaserMeterPoint__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  vrxperience_msgs__msg__LaserMeterPoint * msg = (vrxperience_msgs__msg__LaserMeterPoint *)allocator.allocate(sizeof(vrxperience_msgs__msg__LaserMeterPoint), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(vrxperience_msgs__msg__LaserMeterPoint));
  bool success = vrxperience_msgs__msg__LaserMeterPoint__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
vrxperience_msgs__msg__LaserMeterPoint__destroy(vrxperience_msgs__msg__LaserMeterPoint * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    vrxperience_msgs__msg__LaserMeterPoint__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
vrxperience_msgs__msg__LaserMeterPoint__Sequence__init(vrxperience_msgs__msg__LaserMeterPoint__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  vrxperience_msgs__msg__LaserMeterPoint * data = NULL;

  if (size) {
    data = (vrxperience_msgs__msg__LaserMeterPoint *)allocator.zero_allocate(size, sizeof(vrxperience_msgs__msg__LaserMeterPoint), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = vrxperience_msgs__msg__LaserMeterPoint__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        vrxperience_msgs__msg__LaserMeterPoint__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
vrxperience_msgs__msg__LaserMeterPoint__Sequence__fini(vrxperience_msgs__msg__LaserMeterPoint__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      vrxperience_msgs__msg__LaserMeterPoint__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

vrxperience_msgs__msg__LaserMeterPoint__Sequence *
vrxperience_msgs__msg__LaserMeterPoint__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  vrxperience_msgs__msg__LaserMeterPoint__Sequence * array = (vrxperience_msgs__msg__LaserMeterPoint__Sequence *)allocator.allocate(sizeof(vrxperience_msgs__msg__LaserMeterPoint__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = vrxperience_msgs__msg__LaserMeterPoint__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
vrxperience_msgs__msg__LaserMeterPoint__Sequence__destroy(vrxperience_msgs__msg__LaserMeterPoint__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    vrxperience_msgs__msg__LaserMeterPoint__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
vrxperience_msgs__msg__LaserMeterPoint__Sequence__are_equal(const vrxperience_msgs__msg__LaserMeterPoint__Sequence * lhs, const vrxperience_msgs__msg__LaserMeterPoint__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!vrxperience_msgs__msg__LaserMeterPoint__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
vrxperience_msgs__msg__LaserMeterPoint__Sequence__copy(
  const vrxperience_msgs__msg__LaserMeterPoint__Sequence * input,
  vrxperience_msgs__msg__LaserMeterPoint__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(vrxperience_msgs__msg__LaserMeterPoint);
    vrxperience_msgs__msg__LaserMeterPoint * data =
      (vrxperience_msgs__msg__LaserMeterPoint *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!vrxperience_msgs__msg__LaserMeterPoint__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          vrxperience_msgs__msg__LaserMeterPoint__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!vrxperience_msgs__msg__LaserMeterPoint__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
