// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from vrxperience_msgs:msg/MovableTarget.idl
// generated code does not contain a copyright notice
#include "vrxperience_msgs/msg/detail/movable_target__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `pose`
#include "geometry_msgs/msg/detail/pose__functions.h"
// Member `absolute_speed`
// Member `absolute_angular_speed`
// Member `relative_speed`
// Member `relative_angular_speed`
// Member `absolute_accel`
// Member `relative_accel`
#include "geometry_msgs/msg/detail/vector3__functions.h"

bool
vrxperience_msgs__msg__MovableTarget__init(vrxperience_msgs__msg__MovableTarget * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    vrxperience_msgs__msg__MovableTarget__fini(msg);
    return false;
  }
  // id
  // scaner_id
  // detection_status
  // type
  // beam_index
  // existence_time
  // anchor_point
  // pose
  if (!geometry_msgs__msg__Pose__init(&msg->pose)) {
    vrxperience_msgs__msg__MovableTarget__fini(msg);
    return false;
  }
  // distance_to_collision
  // azimuth_in_sensor
  // elevation_in_sensor
  // azimuth_in_vehicle
  // elevation_in_vehicle
  // absolute_speed
  if (!geometry_msgs__msg__Vector3__init(&msg->absolute_speed)) {
    vrxperience_msgs__msg__MovableTarget__fini(msg);
    return false;
  }
  // absolute_angular_speed
  if (!geometry_msgs__msg__Vector3__init(&msg->absolute_angular_speed)) {
    vrxperience_msgs__msg__MovableTarget__fini(msg);
    return false;
  }
  // relative_speed
  if (!geometry_msgs__msg__Vector3__init(&msg->relative_speed)) {
    vrxperience_msgs__msg__MovableTarget__fini(msg);
    return false;
  }
  // relative_angular_speed
  if (!geometry_msgs__msg__Vector3__init(&msg->relative_angular_speed)) {
    vrxperience_msgs__msg__MovableTarget__fini(msg);
    return false;
  }
  // absolute_accel
  if (!geometry_msgs__msg__Vector3__init(&msg->absolute_accel)) {
    vrxperience_msgs__msg__MovableTarget__fini(msg);
    return false;
  }
  // relative_accel
  if (!geometry_msgs__msg__Vector3__init(&msg->relative_accel)) {
    vrxperience_msgs__msg__MovableTarget__fini(msg);
    return false;
  }
  // length
  // width
  // height
  // visibility
  return true;
}

void
vrxperience_msgs__msg__MovableTarget__fini(vrxperience_msgs__msg__MovableTarget * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // id
  // scaner_id
  // detection_status
  // type
  // beam_index
  // existence_time
  // anchor_point
  // pose
  geometry_msgs__msg__Pose__fini(&msg->pose);
  // distance_to_collision
  // azimuth_in_sensor
  // elevation_in_sensor
  // azimuth_in_vehicle
  // elevation_in_vehicle
  // absolute_speed
  geometry_msgs__msg__Vector3__fini(&msg->absolute_speed);
  // absolute_angular_speed
  geometry_msgs__msg__Vector3__fini(&msg->absolute_angular_speed);
  // relative_speed
  geometry_msgs__msg__Vector3__fini(&msg->relative_speed);
  // relative_angular_speed
  geometry_msgs__msg__Vector3__fini(&msg->relative_angular_speed);
  // absolute_accel
  geometry_msgs__msg__Vector3__fini(&msg->absolute_accel);
  // relative_accel
  geometry_msgs__msg__Vector3__fini(&msg->relative_accel);
  // length
  // width
  // height
  // visibility
}

bool
vrxperience_msgs__msg__MovableTarget__are_equal(const vrxperience_msgs__msg__MovableTarget * lhs, const vrxperience_msgs__msg__MovableTarget * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // id
  if (lhs->id != rhs->id) {
    return false;
  }
  // scaner_id
  if (lhs->scaner_id != rhs->scaner_id) {
    return false;
  }
  // detection_status
  if (lhs->detection_status != rhs->detection_status) {
    return false;
  }
  // type
  if (lhs->type != rhs->type) {
    return false;
  }
  // beam_index
  if (lhs->beam_index != rhs->beam_index) {
    return false;
  }
  // existence_time
  if (lhs->existence_time != rhs->existence_time) {
    return false;
  }
  // anchor_point
  if (lhs->anchor_point != rhs->anchor_point) {
    return false;
  }
  // pose
  if (!geometry_msgs__msg__Pose__are_equal(
      &(lhs->pose), &(rhs->pose)))
  {
    return false;
  }
  // distance_to_collision
  if (lhs->distance_to_collision != rhs->distance_to_collision) {
    return false;
  }
  // azimuth_in_sensor
  if (lhs->azimuth_in_sensor != rhs->azimuth_in_sensor) {
    return false;
  }
  // elevation_in_sensor
  if (lhs->elevation_in_sensor != rhs->elevation_in_sensor) {
    return false;
  }
  // azimuth_in_vehicle
  if (lhs->azimuth_in_vehicle != rhs->azimuth_in_vehicle) {
    return false;
  }
  // elevation_in_vehicle
  if (lhs->elevation_in_vehicle != rhs->elevation_in_vehicle) {
    return false;
  }
  // absolute_speed
  if (!geometry_msgs__msg__Vector3__are_equal(
      &(lhs->absolute_speed), &(rhs->absolute_speed)))
  {
    return false;
  }
  // absolute_angular_speed
  if (!geometry_msgs__msg__Vector3__are_equal(
      &(lhs->absolute_angular_speed), &(rhs->absolute_angular_speed)))
  {
    return false;
  }
  // relative_speed
  if (!geometry_msgs__msg__Vector3__are_equal(
      &(lhs->relative_speed), &(rhs->relative_speed)))
  {
    return false;
  }
  // relative_angular_speed
  if (!geometry_msgs__msg__Vector3__are_equal(
      &(lhs->relative_angular_speed), &(rhs->relative_angular_speed)))
  {
    return false;
  }
  // absolute_accel
  if (!geometry_msgs__msg__Vector3__are_equal(
      &(lhs->absolute_accel), &(rhs->absolute_accel)))
  {
    return false;
  }
  // relative_accel
  if (!geometry_msgs__msg__Vector3__are_equal(
      &(lhs->relative_accel), &(rhs->relative_accel)))
  {
    return false;
  }
  // length
  if (lhs->length != rhs->length) {
    return false;
  }
  // width
  if (lhs->width != rhs->width) {
    return false;
  }
  // height
  if (lhs->height != rhs->height) {
    return false;
  }
  // visibility
  if (lhs->visibility != rhs->visibility) {
    return false;
  }
  return true;
}

bool
vrxperience_msgs__msg__MovableTarget__copy(
  const vrxperience_msgs__msg__MovableTarget * input,
  vrxperience_msgs__msg__MovableTarget * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // id
  output->id = input->id;
  // scaner_id
  output->scaner_id = input->scaner_id;
  // detection_status
  output->detection_status = input->detection_status;
  // type
  output->type = input->type;
  // beam_index
  output->beam_index = input->beam_index;
  // existence_time
  output->existence_time = input->existence_time;
  // anchor_point
  output->anchor_point = input->anchor_point;
  // pose
  if (!geometry_msgs__msg__Pose__copy(
      &(input->pose), &(output->pose)))
  {
    return false;
  }
  // distance_to_collision
  output->distance_to_collision = input->distance_to_collision;
  // azimuth_in_sensor
  output->azimuth_in_sensor = input->azimuth_in_sensor;
  // elevation_in_sensor
  output->elevation_in_sensor = input->elevation_in_sensor;
  // azimuth_in_vehicle
  output->azimuth_in_vehicle = input->azimuth_in_vehicle;
  // elevation_in_vehicle
  output->elevation_in_vehicle = input->elevation_in_vehicle;
  // absolute_speed
  if (!geometry_msgs__msg__Vector3__copy(
      &(input->absolute_speed), &(output->absolute_speed)))
  {
    return false;
  }
  // absolute_angular_speed
  if (!geometry_msgs__msg__Vector3__copy(
      &(input->absolute_angular_speed), &(output->absolute_angular_speed)))
  {
    return false;
  }
  // relative_speed
  if (!geometry_msgs__msg__Vector3__copy(
      &(input->relative_speed), &(output->relative_speed)))
  {
    return false;
  }
  // relative_angular_speed
  if (!geometry_msgs__msg__Vector3__copy(
      &(input->relative_angular_speed), &(output->relative_angular_speed)))
  {
    return false;
  }
  // absolute_accel
  if (!geometry_msgs__msg__Vector3__copy(
      &(input->absolute_accel), &(output->absolute_accel)))
  {
    return false;
  }
  // relative_accel
  if (!geometry_msgs__msg__Vector3__copy(
      &(input->relative_accel), &(output->relative_accel)))
  {
    return false;
  }
  // length
  output->length = input->length;
  // width
  output->width = input->width;
  // height
  output->height = input->height;
  // visibility
  output->visibility = input->visibility;
  return true;
}

vrxperience_msgs__msg__MovableTarget *
vrxperience_msgs__msg__MovableTarget__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  vrxperience_msgs__msg__MovableTarget * msg = (vrxperience_msgs__msg__MovableTarget *)allocator.allocate(sizeof(vrxperience_msgs__msg__MovableTarget), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(vrxperience_msgs__msg__MovableTarget));
  bool success = vrxperience_msgs__msg__MovableTarget__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
vrxperience_msgs__msg__MovableTarget__destroy(vrxperience_msgs__msg__MovableTarget * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    vrxperience_msgs__msg__MovableTarget__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
vrxperience_msgs__msg__MovableTarget__Sequence__init(vrxperience_msgs__msg__MovableTarget__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  vrxperience_msgs__msg__MovableTarget * data = NULL;

  if (size) {
    data = (vrxperience_msgs__msg__MovableTarget *)allocator.zero_allocate(size, sizeof(vrxperience_msgs__msg__MovableTarget), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = vrxperience_msgs__msg__MovableTarget__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        vrxperience_msgs__msg__MovableTarget__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
vrxperience_msgs__msg__MovableTarget__Sequence__fini(vrxperience_msgs__msg__MovableTarget__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      vrxperience_msgs__msg__MovableTarget__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

vrxperience_msgs__msg__MovableTarget__Sequence *
vrxperience_msgs__msg__MovableTarget__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  vrxperience_msgs__msg__MovableTarget__Sequence * array = (vrxperience_msgs__msg__MovableTarget__Sequence *)allocator.allocate(sizeof(vrxperience_msgs__msg__MovableTarget__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = vrxperience_msgs__msg__MovableTarget__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
vrxperience_msgs__msg__MovableTarget__Sequence__destroy(vrxperience_msgs__msg__MovableTarget__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    vrxperience_msgs__msg__MovableTarget__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
vrxperience_msgs__msg__MovableTarget__Sequence__are_equal(const vrxperience_msgs__msg__MovableTarget__Sequence * lhs, const vrxperience_msgs__msg__MovableTarget__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!vrxperience_msgs__msg__MovableTarget__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
vrxperience_msgs__msg__MovableTarget__Sequence__copy(
  const vrxperience_msgs__msg__MovableTarget__Sequence * input,
  vrxperience_msgs__msg__MovableTarget__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(vrxperience_msgs__msg__MovableTarget);
    vrxperience_msgs__msg__MovableTarget * data =
      (vrxperience_msgs__msg__MovableTarget *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!vrxperience_msgs__msg__MovableTarget__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          vrxperience_msgs__msg__MovableTarget__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!vrxperience_msgs__msg__MovableTarget__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
