// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from vrxperience_msgs:msg/MovableTargets.idl
// generated code does not contain a copyright notice
#include "vrxperience_msgs/msg/detail/movable_targets__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `targets`
#include "vrxperience_msgs/msg/detail/movable_target__functions.h"

bool
vrxperience_msgs__msg__MovableTargets__init(vrxperience_msgs__msg__MovableTargets * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    vrxperience_msgs__msg__MovableTargets__fini(msg);
    return false;
  }
  // global_id
  // ego_vehicle_id
  // nearest_target
  // targets
  if (!vrxperience_msgs__msg__MovableTarget__Sequence__init(&msg->targets, 0)) {
    vrxperience_msgs__msg__MovableTargets__fini(msg);
    return false;
  }
  return true;
}

void
vrxperience_msgs__msg__MovableTargets__fini(vrxperience_msgs__msg__MovableTargets * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // global_id
  // ego_vehicle_id
  // nearest_target
  // targets
  vrxperience_msgs__msg__MovableTarget__Sequence__fini(&msg->targets);
}

bool
vrxperience_msgs__msg__MovableTargets__are_equal(const vrxperience_msgs__msg__MovableTargets * lhs, const vrxperience_msgs__msg__MovableTargets * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // global_id
  if (lhs->global_id != rhs->global_id) {
    return false;
  }
  // ego_vehicle_id
  if (lhs->ego_vehicle_id != rhs->ego_vehicle_id) {
    return false;
  }
  // nearest_target
  if (lhs->nearest_target != rhs->nearest_target) {
    return false;
  }
  // targets
  if (!vrxperience_msgs__msg__MovableTarget__Sequence__are_equal(
      &(lhs->targets), &(rhs->targets)))
  {
    return false;
  }
  return true;
}

bool
vrxperience_msgs__msg__MovableTargets__copy(
  const vrxperience_msgs__msg__MovableTargets * input,
  vrxperience_msgs__msg__MovableTargets * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // global_id
  output->global_id = input->global_id;
  // ego_vehicle_id
  output->ego_vehicle_id = input->ego_vehicle_id;
  // nearest_target
  output->nearest_target = input->nearest_target;
  // targets
  if (!vrxperience_msgs__msg__MovableTarget__Sequence__copy(
      &(input->targets), &(output->targets)))
  {
    return false;
  }
  return true;
}

vrxperience_msgs__msg__MovableTargets *
vrxperience_msgs__msg__MovableTargets__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  vrxperience_msgs__msg__MovableTargets * msg = (vrxperience_msgs__msg__MovableTargets *)allocator.allocate(sizeof(vrxperience_msgs__msg__MovableTargets), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(vrxperience_msgs__msg__MovableTargets));
  bool success = vrxperience_msgs__msg__MovableTargets__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
vrxperience_msgs__msg__MovableTargets__destroy(vrxperience_msgs__msg__MovableTargets * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    vrxperience_msgs__msg__MovableTargets__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
vrxperience_msgs__msg__MovableTargets__Sequence__init(vrxperience_msgs__msg__MovableTargets__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  vrxperience_msgs__msg__MovableTargets * data = NULL;

  if (size) {
    data = (vrxperience_msgs__msg__MovableTargets *)allocator.zero_allocate(size, sizeof(vrxperience_msgs__msg__MovableTargets), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = vrxperience_msgs__msg__MovableTargets__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        vrxperience_msgs__msg__MovableTargets__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
vrxperience_msgs__msg__MovableTargets__Sequence__fini(vrxperience_msgs__msg__MovableTargets__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      vrxperience_msgs__msg__MovableTargets__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

vrxperience_msgs__msg__MovableTargets__Sequence *
vrxperience_msgs__msg__MovableTargets__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  vrxperience_msgs__msg__MovableTargets__Sequence * array = (vrxperience_msgs__msg__MovableTargets__Sequence *)allocator.allocate(sizeof(vrxperience_msgs__msg__MovableTargets__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = vrxperience_msgs__msg__MovableTargets__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
vrxperience_msgs__msg__MovableTargets__Sequence__destroy(vrxperience_msgs__msg__MovableTargets__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    vrxperience_msgs__msg__MovableTargets__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
vrxperience_msgs__msg__MovableTargets__Sequence__are_equal(const vrxperience_msgs__msg__MovableTargets__Sequence * lhs, const vrxperience_msgs__msg__MovableTargets__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!vrxperience_msgs__msg__MovableTargets__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
vrxperience_msgs__msg__MovableTargets__Sequence__copy(
  const vrxperience_msgs__msg__MovableTargets__Sequence * input,
  vrxperience_msgs__msg__MovableTargets__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(vrxperience_msgs__msg__MovableTargets);
    vrxperience_msgs__msg__MovableTargets * data =
      (vrxperience_msgs__msg__MovableTargets *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!vrxperience_msgs__msg__MovableTargets__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          vrxperience_msgs__msg__MovableTargets__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!vrxperience_msgs__msg__MovableTargets__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
