// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from vrxperience_msgs:msg/MovableTargets.idl
// generated code does not contain a copyright notice

#ifndef VRXPERIENCE_MSGS__MSG__DETAIL__MOVABLE_TARGETS__STRUCT_HPP_
#define VRXPERIENCE_MSGS__MSG__DETAIL__MOVABLE_TARGETS__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'targets'
#include "vrxperience_msgs/msg/detail/movable_target__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__vrxperience_msgs__msg__MovableTargets __attribute__((deprecated))
#else
# define DEPRECATED__vrxperience_msgs__msg__MovableTargets __declspec(deprecated)
#endif

namespace vrxperience_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MovableTargets_
{
  using Type = MovableTargets_<ContainerAllocator>;

  explicit MovableTargets_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->global_id = 0l;
      this->ego_vehicle_id = 0;
      this->nearest_target = 0;
    }
  }

  explicit MovableTargets_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->global_id = 0l;
      this->ego_vehicle_id = 0;
      this->nearest_target = 0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _global_id_type =
    int32_t;
  _global_id_type global_id;
  using _ego_vehicle_id_type =
    int16_t;
  _ego_vehicle_id_type ego_vehicle_id;
  using _nearest_target_type =
    int16_t;
  _nearest_target_type nearest_target;
  using _targets_type =
    rosidl_runtime_cpp::BoundedVector<vrxperience_msgs::msg::MovableTarget_<ContainerAllocator>, 30, typename ContainerAllocator::template rebind<vrxperience_msgs::msg::MovableTarget_<ContainerAllocator>>::other>;
  _targets_type targets;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__global_id(
    const int32_t & _arg)
  {
    this->global_id = _arg;
    return *this;
  }
  Type & set__ego_vehicle_id(
    const int16_t & _arg)
  {
    this->ego_vehicle_id = _arg;
    return *this;
  }
  Type & set__nearest_target(
    const int16_t & _arg)
  {
    this->nearest_target = _arg;
    return *this;
  }
  Type & set__targets(
    const rosidl_runtime_cpp::BoundedVector<vrxperience_msgs::msg::MovableTarget_<ContainerAllocator>, 30, typename ContainerAllocator::template rebind<vrxperience_msgs::msg::MovableTarget_<ContainerAllocator>>::other> & _arg)
  {
    this->targets = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    vrxperience_msgs::msg::MovableTargets_<ContainerAllocator> *;
  using ConstRawPtr =
    const vrxperience_msgs::msg::MovableTargets_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<vrxperience_msgs::msg::MovableTargets_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<vrxperience_msgs::msg::MovableTargets_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      vrxperience_msgs::msg::MovableTargets_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<vrxperience_msgs::msg::MovableTargets_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      vrxperience_msgs::msg::MovableTargets_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<vrxperience_msgs::msg::MovableTargets_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<vrxperience_msgs::msg::MovableTargets_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<vrxperience_msgs::msg::MovableTargets_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__vrxperience_msgs__msg__MovableTargets
    std::shared_ptr<vrxperience_msgs::msg::MovableTargets_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__vrxperience_msgs__msg__MovableTargets
    std::shared_ptr<vrxperience_msgs::msg::MovableTargets_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MovableTargets_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->global_id != other.global_id) {
      return false;
    }
    if (this->ego_vehicle_id != other.ego_vehicle_id) {
      return false;
    }
    if (this->nearest_target != other.nearest_target) {
      return false;
    }
    if (this->targets != other.targets) {
      return false;
    }
    return true;
  }
  bool operator!=(const MovableTargets_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MovableTargets_

// alias to use template instance with default allocator
using MovableTargets =
  vrxperience_msgs::msg::MovableTargets_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace vrxperience_msgs

#endif  // VRXPERIENCE_MSGS__MSG__DETAIL__MOVABLE_TARGETS__STRUCT_HPP_
