// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from vrxperience_msgs:msg/CabToModelCorrective.idl
// generated code does not contain a copyright notice

#ifndef VRXPERIENCE_MSGS__MSG__DETAIL__CAB_TO_MODEL_CORRECTIVE__STRUCT_H_
#define VRXPERIENCE_MSGS__MSG__DETAIL__CAB_TO_MODEL_CORRECTIVE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

/// Constant 'T_AUTO_MODE_MANUAL'.
enum
{
  vrxperience_msgs__msg__CabToModelCorrective__T_AUTO_MODE_MANUAL = 0
};

/// Constant 'T_AUTO_MODE_REVERSE2'.
enum
{
  vrxperience_msgs__msg__CabToModelCorrective__T_AUTO_MODE_REVERSE2 = 1
};

/// Constant 'T_AUTO_MODE_REVERSE1'.
enum
{
  vrxperience_msgs__msg__CabToModelCorrective__T_AUTO_MODE_REVERSE1 = 2
};

/// Constant 'T_AUTO_MODE_NEUTRAL'.
enum
{
  vrxperience_msgs__msg__CabToModelCorrective__T_AUTO_MODE_NEUTRAL = 3
};

/// Constant 'T_AUTO_MODE_PARK'.
enum
{
  vrxperience_msgs__msg__CabToModelCorrective__T_AUTO_MODE_PARK = 4
};

/// Constant 'T_AUTO_MODE_LIMIT1'.
enum
{
  vrxperience_msgs__msg__CabToModelCorrective__T_AUTO_MODE_LIMIT1 = 5
};

/// Constant 'T_AUTO_MODE_LIMIT2'.
enum
{
  vrxperience_msgs__msg__CabToModelCorrective__T_AUTO_MODE_LIMIT2 = 6
};

/// Constant 'T_AUTO_MODE_LIMIT3'.
enum
{
  vrxperience_msgs__msg__CabToModelCorrective__T_AUTO_MODE_LIMIT3 = 7
};

/// Constant 'T_AUTO_MODE_LIMIT4'.
enum
{
  vrxperience_msgs__msg__CabToModelCorrective__T_AUTO_MODE_LIMIT4 = 8
};

/// Constant 'T_AUTO_MODE_RACE'.
enum
{
  vrxperience_msgs__msg__CabToModelCorrective__T_AUTO_MODE_RACE = 9
};

/// Constant 'T_AUTO_MODE_DRIVE'.
enum
{
  vrxperience_msgs__msg__CabToModelCorrective__T_AUTO_MODE_DRIVE = 10
};

/// Constant 'T_AUTO_MODE_OVER_DRIVE'.
enum
{
  vrxperience_msgs__msg__CabToModelCorrective__T_AUTO_MODE_OVER_DRIVE = 11
};

/// Constant 'SEQUENTIAL'.
enum
{
  vrxperience_msgs__msg__CabToModelCorrective__SEQUENTIAL = 12
};

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.h"

// Struct defined in msg/CabToModelCorrective in the package vrxperience_msgs.
typedef struct vrxperience_msgs__msg__CabToModelCorrective
{
  std_msgs__msg__Header header;
  double accelerator_additive;
  double accelerator_multiplicative;
  double brake_additive;
  double brake_multiplicative;
  double clutch_additive;
  double clutch_multiplicative;
  double parking_brake_additive;
  double parking_brake_multiplicative;
  bool gear_box_take_over;
  int16_t gear_box_auto_mode;
  int16_t wanted_gear;
  bool shift_up;
  bool shift_down;
  bool is_ratio_limit;
  int16_t min_ratio;
  int16_t max_ratio;
} vrxperience_msgs__msg__CabToModelCorrective;

// Struct for a sequence of vrxperience_msgs__msg__CabToModelCorrective.
typedef struct vrxperience_msgs__msg__CabToModelCorrective__Sequence
{
  vrxperience_msgs__msg__CabToModelCorrective * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} vrxperience_msgs__msg__CabToModelCorrective__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // VRXPERIENCE_MSGS__MSG__DETAIL__CAB_TO_MODEL_CORRECTIVE__STRUCT_H_
