// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from vrxperience_msgs:msg/CabToSteeringCorrective.idl
// generated code does not contain a copyright notice

#ifndef VRXPERIENCE_MSGS__MSG__DETAIL__CAB_TO_STEERING_CORRECTIVE__FUNCTIONS_H_
#define VRXPERIENCE_MSGS__MSG__DETAIL__CAB_TO_STEERING_CORRECTIVE__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "vrxperience_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "vrxperience_msgs/msg/detail/cab_to_steering_corrective__struct.h"

/// Initialize msg/CabToSteeringCorrective message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * vrxperience_msgs__msg__CabToSteeringCorrective
 * )) before or use
 * vrxperience_msgs__msg__CabToSteeringCorrective__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_vrxperience_msgs
bool
vrxperience_msgs__msg__CabToSteeringCorrective__init(vrxperience_msgs__msg__CabToSteeringCorrective * msg);

/// Finalize msg/CabToSteeringCorrective message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_vrxperience_msgs
void
vrxperience_msgs__msg__CabToSteeringCorrective__fini(vrxperience_msgs__msg__CabToSteeringCorrective * msg);

/// Create msg/CabToSteeringCorrective message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * vrxperience_msgs__msg__CabToSteeringCorrective__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_vrxperience_msgs
vrxperience_msgs__msg__CabToSteeringCorrective *
vrxperience_msgs__msg__CabToSteeringCorrective__create();

/// Destroy msg/CabToSteeringCorrective message.
/**
 * It calls
 * vrxperience_msgs__msg__CabToSteeringCorrective__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_vrxperience_msgs
void
vrxperience_msgs__msg__CabToSteeringCorrective__destroy(vrxperience_msgs__msg__CabToSteeringCorrective * msg);

/// Check for msg/CabToSteeringCorrective message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_vrxperience_msgs
bool
vrxperience_msgs__msg__CabToSteeringCorrective__are_equal(const vrxperience_msgs__msg__CabToSteeringCorrective * lhs, const vrxperience_msgs__msg__CabToSteeringCorrective * rhs);

/// Copy a msg/CabToSteeringCorrective message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_vrxperience_msgs
bool
vrxperience_msgs__msg__CabToSteeringCorrective__copy(
  const vrxperience_msgs__msg__CabToSteeringCorrective * input,
  vrxperience_msgs__msg__CabToSteeringCorrective * output);

/// Initialize array of msg/CabToSteeringCorrective messages.
/**
 * It allocates the memory for the number of elements and calls
 * vrxperience_msgs__msg__CabToSteeringCorrective__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_vrxperience_msgs
bool
vrxperience_msgs__msg__CabToSteeringCorrective__Sequence__init(vrxperience_msgs__msg__CabToSteeringCorrective__Sequence * array, size_t size);

/// Finalize array of msg/CabToSteeringCorrective messages.
/**
 * It calls
 * vrxperience_msgs__msg__CabToSteeringCorrective__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_vrxperience_msgs
void
vrxperience_msgs__msg__CabToSteeringCorrective__Sequence__fini(vrxperience_msgs__msg__CabToSteeringCorrective__Sequence * array);

/// Create array of msg/CabToSteeringCorrective messages.
/**
 * It allocates the memory for the array and calls
 * vrxperience_msgs__msg__CabToSteeringCorrective__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_vrxperience_msgs
vrxperience_msgs__msg__CabToSteeringCorrective__Sequence *
vrxperience_msgs__msg__CabToSteeringCorrective__Sequence__create(size_t size);

/// Destroy array of msg/CabToSteeringCorrective messages.
/**
 * It calls
 * vrxperience_msgs__msg__CabToSteeringCorrective__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_vrxperience_msgs
void
vrxperience_msgs__msg__CabToSteeringCorrective__Sequence__destroy(vrxperience_msgs__msg__CabToSteeringCorrective__Sequence * array);

/// Check for msg/CabToSteeringCorrective message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_vrxperience_msgs
bool
vrxperience_msgs__msg__CabToSteeringCorrective__Sequence__are_equal(const vrxperience_msgs__msg__CabToSteeringCorrective__Sequence * lhs, const vrxperience_msgs__msg__CabToSteeringCorrective__Sequence * rhs);

/// Copy an array of msg/CabToSteeringCorrective messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_vrxperience_msgs
bool
vrxperience_msgs__msg__CabToSteeringCorrective__Sequence__copy(
  const vrxperience_msgs__msg__CabToSteeringCorrective__Sequence * input,
  vrxperience_msgs__msg__CabToSteeringCorrective__Sequence * output);

#ifdef __cplusplus
}
#endif

#endif  // VRXPERIENCE_MSGS__MSG__DETAIL__CAB_TO_STEERING_CORRECTIVE__FUNCTIONS_H_
