// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from vrxperience_msgs:msg/MovableTarget.idl
// generated code does not contain a copyright notice

#ifndef VRXPERIENCE_MSGS__MSG__DETAIL__MOVABLE_TARGET__STRUCT_HPP_
#define VRXPERIENCE_MSGS__MSG__DETAIL__MOVABLE_TARGET__STRUCT_HPP_

#include <rosidl_runtime_cpp/bounded_vector.hpp>
#include <rosidl_runtime_cpp/message_initialization.hpp>
#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'pose'
#include "geometry_msgs/msg/detail/pose__struct.hpp"
// Member 'absolute_speed'
// Member 'absolute_angular_speed'
// Member 'relative_speed'
// Member 'relative_angular_speed'
// Member 'absolute_accel'
// Member 'relative_accel'
#include "geometry_msgs/msg/detail/vector3__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__vrxperience_msgs__msg__MovableTarget __attribute__((deprecated))
#else
# define DEPRECATED__vrxperience_msgs__msg__MovableTarget __declspec(deprecated)
#endif

namespace vrxperience_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct MovableTarget_
{
  using Type = MovableTarget_<ContainerAllocator>;

  explicit MovableTarget_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    pose(_init),
    absolute_speed(_init),
    absolute_angular_speed(_init),
    relative_speed(_init),
    relative_angular_speed(_init),
    absolute_accel(_init),
    relative_accel(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0;
      this->scaner_id = 0;
      this->detection_status = 0;
      this->type = 0;
      this->beam_index = 0;
      this->existence_time = 0.0;
      this->anchor_point = 0;
      this->distance_to_collision = 0.0f;
      this->azimuth_in_sensor = 0.0f;
      this->elevation_in_sensor = 0.0f;
      this->azimuth_in_vehicle = 0.0f;
      this->elevation_in_vehicle = 0.0f;
      this->length = 0.0f;
      this->width = 0.0f;
      this->height = 0.0f;
      this->visibility = 0.0f;
    }
  }

  explicit MovableTarget_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    pose(_alloc, _init),
    absolute_speed(_alloc, _init),
    absolute_angular_speed(_alloc, _init),
    relative_speed(_alloc, _init),
    relative_angular_speed(_alloc, _init),
    absolute_accel(_alloc, _init),
    relative_accel(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0;
      this->scaner_id = 0;
      this->detection_status = 0;
      this->type = 0;
      this->beam_index = 0;
      this->existence_time = 0.0;
      this->anchor_point = 0;
      this->distance_to_collision = 0.0f;
      this->azimuth_in_sensor = 0.0f;
      this->elevation_in_sensor = 0.0f;
      this->azimuth_in_vehicle = 0.0f;
      this->elevation_in_vehicle = 0.0f;
      this->length = 0.0f;
      this->width = 0.0f;
      this->height = 0.0f;
      this->visibility = 0.0f;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _id_type =
    int16_t;
  _id_type id;
  using _scaner_id_type =
    int16_t;
  _scaner_id_type scaner_id;
  using _detection_status_type =
    int16_t;
  _detection_status_type detection_status;
  using _type_type =
    int16_t;
  _type_type type;
  using _beam_index_type =
    int16_t;
  _beam_index_type beam_index;
  using _existence_time_type =
    double;
  _existence_time_type existence_time;
  using _anchor_point_type =
    int16_t;
  _anchor_point_type anchor_point;
  using _pose_type =
    geometry_msgs::msg::Pose_<ContainerAllocator>;
  _pose_type pose;
  using _distance_to_collision_type =
    float;
  _distance_to_collision_type distance_to_collision;
  using _azimuth_in_sensor_type =
    float;
  _azimuth_in_sensor_type azimuth_in_sensor;
  using _elevation_in_sensor_type =
    float;
  _elevation_in_sensor_type elevation_in_sensor;
  using _azimuth_in_vehicle_type =
    float;
  _azimuth_in_vehicle_type azimuth_in_vehicle;
  using _elevation_in_vehicle_type =
    float;
  _elevation_in_vehicle_type elevation_in_vehicle;
  using _absolute_speed_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _absolute_speed_type absolute_speed;
  using _absolute_angular_speed_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _absolute_angular_speed_type absolute_angular_speed;
  using _relative_speed_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _relative_speed_type relative_speed;
  using _relative_angular_speed_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _relative_angular_speed_type relative_angular_speed;
  using _absolute_accel_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _absolute_accel_type absolute_accel;
  using _relative_accel_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _relative_accel_type relative_accel;
  using _length_type =
    float;
  _length_type length;
  using _width_type =
    float;
  _width_type width;
  using _height_type =
    float;
  _height_type height;
  using _visibility_type =
    float;
  _visibility_type visibility;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__id(
    const int16_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__scaner_id(
    const int16_t & _arg)
  {
    this->scaner_id = _arg;
    return *this;
  }
  Type & set__detection_status(
    const int16_t & _arg)
  {
    this->detection_status = _arg;
    return *this;
  }
  Type & set__type(
    const int16_t & _arg)
  {
    this->type = _arg;
    return *this;
  }
  Type & set__beam_index(
    const int16_t & _arg)
  {
    this->beam_index = _arg;
    return *this;
  }
  Type & set__existence_time(
    const double & _arg)
  {
    this->existence_time = _arg;
    return *this;
  }
  Type & set__anchor_point(
    const int16_t & _arg)
  {
    this->anchor_point = _arg;
    return *this;
  }
  Type & set__pose(
    const geometry_msgs::msg::Pose_<ContainerAllocator> & _arg)
  {
    this->pose = _arg;
    return *this;
  }
  Type & set__distance_to_collision(
    const float & _arg)
  {
    this->distance_to_collision = _arg;
    return *this;
  }
  Type & set__azimuth_in_sensor(
    const float & _arg)
  {
    this->azimuth_in_sensor = _arg;
    return *this;
  }
  Type & set__elevation_in_sensor(
    const float & _arg)
  {
    this->elevation_in_sensor = _arg;
    return *this;
  }
  Type & set__azimuth_in_vehicle(
    const float & _arg)
  {
    this->azimuth_in_vehicle = _arg;
    return *this;
  }
  Type & set__elevation_in_vehicle(
    const float & _arg)
  {
    this->elevation_in_vehicle = _arg;
    return *this;
  }
  Type & set__absolute_speed(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->absolute_speed = _arg;
    return *this;
  }
  Type & set__absolute_angular_speed(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->absolute_angular_speed = _arg;
    return *this;
  }
  Type & set__relative_speed(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->relative_speed = _arg;
    return *this;
  }
  Type & set__relative_angular_speed(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->relative_angular_speed = _arg;
    return *this;
  }
  Type & set__absolute_accel(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->absolute_accel = _arg;
    return *this;
  }
  Type & set__relative_accel(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->relative_accel = _arg;
    return *this;
  }
  Type & set__length(
    const float & _arg)
  {
    this->length = _arg;
    return *this;
  }
  Type & set__width(
    const float & _arg)
  {
    this->width = _arg;
    return *this;
  }
  Type & set__height(
    const float & _arg)
  {
    this->height = _arg;
    return *this;
  }
  Type & set__visibility(
    const float & _arg)
  {
    this->visibility = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int16_t DETECTION_STATUS_UNDEFINED =
    0;
  static constexpr int16_t DETECTION_STATUS_NEW_TARGET =
    1;
  static constexpr int16_t DETECTION_STATUS_EXISTING_TARGET =
    2;
  static constexpr float HIDDEN =
    0.0;
  static constexpr float VISIBLE =
    1.0;

  // pointer types
  using RawPtr =
    vrxperience_msgs::msg::MovableTarget_<ContainerAllocator> *;
  using ConstRawPtr =
    const vrxperience_msgs::msg::MovableTarget_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<vrxperience_msgs::msg::MovableTarget_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<vrxperience_msgs::msg::MovableTarget_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      vrxperience_msgs::msg::MovableTarget_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<vrxperience_msgs::msg::MovableTarget_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      vrxperience_msgs::msg::MovableTarget_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<vrxperience_msgs::msg::MovableTarget_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<vrxperience_msgs::msg::MovableTarget_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<vrxperience_msgs::msg::MovableTarget_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__vrxperience_msgs__msg__MovableTarget
    std::shared_ptr<vrxperience_msgs::msg::MovableTarget_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__vrxperience_msgs__msg__MovableTarget
    std::shared_ptr<vrxperience_msgs::msg::MovableTarget_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const MovableTarget_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->id != other.id) {
      return false;
    }
    if (this->scaner_id != other.scaner_id) {
      return false;
    }
    if (this->detection_status != other.detection_status) {
      return false;
    }
    if (this->type != other.type) {
      return false;
    }
    if (this->beam_index != other.beam_index) {
      return false;
    }
    if (this->existence_time != other.existence_time) {
      return false;
    }
    if (this->anchor_point != other.anchor_point) {
      return false;
    }
    if (this->pose != other.pose) {
      return false;
    }
    if (this->distance_to_collision != other.distance_to_collision) {
      return false;
    }
    if (this->azimuth_in_sensor != other.azimuth_in_sensor) {
      return false;
    }
    if (this->elevation_in_sensor != other.elevation_in_sensor) {
      return false;
    }
    if (this->azimuth_in_vehicle != other.azimuth_in_vehicle) {
      return false;
    }
    if (this->elevation_in_vehicle != other.elevation_in_vehicle) {
      return false;
    }
    if (this->absolute_speed != other.absolute_speed) {
      return false;
    }
    if (this->absolute_angular_speed != other.absolute_angular_speed) {
      return false;
    }
    if (this->relative_speed != other.relative_speed) {
      return false;
    }
    if (this->relative_angular_speed != other.relative_angular_speed) {
      return false;
    }
    if (this->absolute_accel != other.absolute_accel) {
      return false;
    }
    if (this->relative_accel != other.relative_accel) {
      return false;
    }
    if (this->length != other.length) {
      return false;
    }
    if (this->width != other.width) {
      return false;
    }
    if (this->height != other.height) {
      return false;
    }
    if (this->visibility != other.visibility) {
      return false;
    }
    return true;
  }
  bool operator!=(const MovableTarget_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct MovableTarget_

// alias to use template instance with default allocator
using MovableTarget =
  vrxperience_msgs::msg::MovableTarget_<std::allocator<void>>;

// constant definitions
template<typename ContainerAllocator>
constexpr int16_t MovableTarget_<ContainerAllocator>::DETECTION_STATUS_UNDEFINED;
template<typename ContainerAllocator>
constexpr int16_t MovableTarget_<ContainerAllocator>::DETECTION_STATUS_NEW_TARGET;
template<typename ContainerAllocator>
constexpr int16_t MovableTarget_<ContainerAllocator>::DETECTION_STATUS_EXISTING_TARGET;
template<typename ContainerAllocator>
constexpr float MovableTarget_<ContainerAllocator>::HIDDEN;
template<typename ContainerAllocator>
constexpr float MovableTarget_<ContainerAllocator>::VISIBLE;

}  // namespace msg

}  // namespace vrxperience_msgs

#endif  // VRXPERIENCE_MSGS__MSG__DETAIL__MOVABLE_TARGET__STRUCT_HPP_
