// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from vrxperience_msgs:msg/RoadLinePolynom.idl
// generated code does not contain a copyright notice
#include "vrxperience_msgs/msg/detail/road_line_polynom__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


bool
vrxperience_msgs__msg__RoadLinePolynom__init(vrxperience_msgs__msg__RoadLinePolynom * msg)
{
  if (!msg) {
    return false;
  }
  // line_id
  // c0
  // c1
  // c2
  // c3
  // curvature_radius
  // estimated_curvature_radius
  return true;
}

void
vrxperience_msgs__msg__RoadLinePolynom__fini(vrxperience_msgs__msg__RoadLinePolynom * msg)
{
  if (!msg) {
    return;
  }
  // line_id
  // c0
  // c1
  // c2
  // c3
  // curvature_radius
  // estimated_curvature_radius
}

bool
vrxperience_msgs__msg__RoadLinePolynom__are_equal(const vrxperience_msgs__msg__RoadLinePolynom * lhs, const vrxperience_msgs__msg__RoadLinePolynom * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // line_id
  if (lhs->line_id != rhs->line_id) {
    return false;
  }
  // c0
  if (lhs->c0 != rhs->c0) {
    return false;
  }
  // c1
  if (lhs->c1 != rhs->c1) {
    return false;
  }
  // c2
  if (lhs->c2 != rhs->c2) {
    return false;
  }
  // c3
  if (lhs->c3 != rhs->c3) {
    return false;
  }
  // curvature_radius
  if (lhs->curvature_radius != rhs->curvature_radius) {
    return false;
  }
  // estimated_curvature_radius
  if (lhs->estimated_curvature_radius != rhs->estimated_curvature_radius) {
    return false;
  }
  return true;
}

bool
vrxperience_msgs__msg__RoadLinePolynom__copy(
  const vrxperience_msgs__msg__RoadLinePolynom * input,
  vrxperience_msgs__msg__RoadLinePolynom * output)
{
  if (!input || !output) {
    return false;
  }
  // line_id
  output->line_id = input->line_id;
  // c0
  output->c0 = input->c0;
  // c1
  output->c1 = input->c1;
  // c2
  output->c2 = input->c2;
  // c3
  output->c3 = input->c3;
  // curvature_radius
  output->curvature_radius = input->curvature_radius;
  // estimated_curvature_radius
  output->estimated_curvature_radius = input->estimated_curvature_radius;
  return true;
}

vrxperience_msgs__msg__RoadLinePolynom *
vrxperience_msgs__msg__RoadLinePolynom__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  vrxperience_msgs__msg__RoadLinePolynom * msg = (vrxperience_msgs__msg__RoadLinePolynom *)allocator.allocate(sizeof(vrxperience_msgs__msg__RoadLinePolynom), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(vrxperience_msgs__msg__RoadLinePolynom));
  bool success = vrxperience_msgs__msg__RoadLinePolynom__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
vrxperience_msgs__msg__RoadLinePolynom__destroy(vrxperience_msgs__msg__RoadLinePolynom * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    vrxperience_msgs__msg__RoadLinePolynom__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
vrxperience_msgs__msg__RoadLinePolynom__Sequence__init(vrxperience_msgs__msg__RoadLinePolynom__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  vrxperience_msgs__msg__RoadLinePolynom * data = NULL;

  if (size) {
    data = (vrxperience_msgs__msg__RoadLinePolynom *)allocator.zero_allocate(size, sizeof(vrxperience_msgs__msg__RoadLinePolynom), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = vrxperience_msgs__msg__RoadLinePolynom__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        vrxperience_msgs__msg__RoadLinePolynom__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
vrxperience_msgs__msg__RoadLinePolynom__Sequence__fini(vrxperience_msgs__msg__RoadLinePolynom__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      vrxperience_msgs__msg__RoadLinePolynom__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

vrxperience_msgs__msg__RoadLinePolynom__Sequence *
vrxperience_msgs__msg__RoadLinePolynom__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  vrxperience_msgs__msg__RoadLinePolynom__Sequence * array = (vrxperience_msgs__msg__RoadLinePolynom__Sequence *)allocator.allocate(sizeof(vrxperience_msgs__msg__RoadLinePolynom__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = vrxperience_msgs__msg__RoadLinePolynom__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
vrxperience_msgs__msg__RoadLinePolynom__Sequence__destroy(vrxperience_msgs__msg__RoadLinePolynom__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    vrxperience_msgs__msg__RoadLinePolynom__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
vrxperience_msgs__msg__RoadLinePolynom__Sequence__are_equal(const vrxperience_msgs__msg__RoadLinePolynom__Sequence * lhs, const vrxperience_msgs__msg__RoadLinePolynom__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!vrxperience_msgs__msg__RoadLinePolynom__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
vrxperience_msgs__msg__RoadLinePolynom__Sequence__copy(
  const vrxperience_msgs__msg__RoadLinePolynom__Sequence * input,
  vrxperience_msgs__msg__RoadLinePolynom__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(vrxperience_msgs__msg__RoadLinePolynom);
    vrxperience_msgs__msg__RoadLinePolynom * data =
      (vrxperience_msgs__msg__RoadLinePolynom *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!vrxperience_msgs__msg__RoadLinePolynom__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          vrxperience_msgs__msg__RoadLinePolynom__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!vrxperience_msgs__msg__RoadLinePolynom__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
