// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from vrxperience_msgs:msg/VehicleOutput.idl
// generated code does not contain a copyright notice
#include "vrxperience_msgs/msg/detail/vehicle_output__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `header`
#include "std_msgs/msg/detail/header__functions.h"
// Member `cdg_speed`
// Member `cdg_angular_speed`
// Member `cdg_accel`
// Member `cdg_angular_accel`
// Member `cdg_position`
// Member `cdg_orientation`
// Member `hub_orientation`
// Member `ground_normals`
// Member `tire_force`
#include "geometry_msgs/msg/detail/vector3__functions.h"
// Member `hub_position`
// Member `contact_points`
#include "geometry_msgs/msg/detail/point__functions.h"

bool
vrxperience_msgs__msg__VehicleOutput__init(vrxperience_msgs__msg__VehicleOutput * msg)
{
  if (!msg) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__init(&msg->header)) {
    vrxperience_msgs__msg__VehicleOutput__fini(msg);
    return false;
  }
  // cdg_speed
  if (!geometry_msgs__msg__Vector3__init(&msg->cdg_speed)) {
    vrxperience_msgs__msg__VehicleOutput__fini(msg);
    return false;
  }
  // cdg_angular_speed
  if (!geometry_msgs__msg__Vector3__init(&msg->cdg_angular_speed)) {
    vrxperience_msgs__msg__VehicleOutput__fini(msg);
    return false;
  }
  // cdg_accel
  if (!geometry_msgs__msg__Vector3__init(&msg->cdg_accel)) {
    vrxperience_msgs__msg__VehicleOutput__fini(msg);
    return false;
  }
  // cdg_angular_accel
  if (!geometry_msgs__msg__Vector3__init(&msg->cdg_angular_accel)) {
    vrxperience_msgs__msg__VehicleOutput__fini(msg);
    return false;
  }
  // cdg_position
  if (!geometry_msgs__msg__Vector3__init(&msg->cdg_position)) {
    vrxperience_msgs__msg__VehicleOutput__fini(msg);
    return false;
  }
  // cdg_orientation
  if (!geometry_msgs__msg__Vector3__init(&msg->cdg_orientation)) {
    vrxperience_msgs__msg__VehicleOutput__fini(msg);
    return false;
  }
  // lights
  // sirens
  // auxilary_lights
  // engine_state
  // consumption
  // pollution
  // engine_speed
  // gear_engaged
  // gas_pedal
  // brake_pedal
  // hand_brake
  // clutch_pedal
  // gear_box_mode
  // effective_ignition_key_position
  // is_engine_retarder
  // brake_retarder_notch
  // trailer_brake
  // transfer_choice
  // lock_diff_mode
  // force_lockup
  // plow_mode
  // steering_wheel_angle
  // steering_wheel_speed
  // steering_wheel_accel
  // steering_wheel_torque
  // hub_position
  for (size_t i = 0; i < 4; ++i) {
    if (!geometry_msgs__msg__Point__init(&msg->hub_position[i])) {
      vrxperience_msgs__msg__VehicleOutput__fini(msg);
      return false;
    }
  }
  // hub_orientation
  for (size_t i = 0; i < 4; ++i) {
    if (!geometry_msgs__msg__Vector3__init(&msg->hub_orientation[i])) {
      vrxperience_msgs__msg__VehicleOutput__fini(msg);
      return false;
    }
  }
  // wheel_rotation
  // wheel_rotation_speed
  // brake_temperature
  // abs_is_active
  // is_in_contact
  // contact_points
  for (size_t i = 0; i < 4; ++i) {
    if (!geometry_msgs__msg__Point__init(&msg->contact_points[i])) {
      vrxperience_msgs__msg__VehicleOutput__fini(msg);
      return false;
    }
  }
  // ground_normals
  for (size_t i = 0; i < 4; ++i) {
    if (!geometry_msgs__msg__Vector3__init(&msg->ground_normals[i])) {
      vrxperience_msgs__msg__VehicleOutput__fini(msg);
      return false;
    }
  }
  // grip
  // ground_index
  // lsr
  // slip_angle
  // tire_force
  for (size_t i = 0; i < 4; ++i) {
    if (!geometry_msgs__msg__Vector3__init(&msg->tire_force[i])) {
      vrxperience_msgs__msg__VehicleOutput__fini(msg);
      return false;
    }
  }
  // lane_type
  // roughness_height
  // roughness_length
  // roughness_height_stddev
  // roughness_length_stddev
  // ground_type
  // water_height
  // custom_output
  return true;
}

void
vrxperience_msgs__msg__VehicleOutput__fini(vrxperience_msgs__msg__VehicleOutput * msg)
{
  if (!msg) {
    return;
  }
  // header
  std_msgs__msg__Header__fini(&msg->header);
  // cdg_speed
  geometry_msgs__msg__Vector3__fini(&msg->cdg_speed);
  // cdg_angular_speed
  geometry_msgs__msg__Vector3__fini(&msg->cdg_angular_speed);
  // cdg_accel
  geometry_msgs__msg__Vector3__fini(&msg->cdg_accel);
  // cdg_angular_accel
  geometry_msgs__msg__Vector3__fini(&msg->cdg_angular_accel);
  // cdg_position
  geometry_msgs__msg__Vector3__fini(&msg->cdg_position);
  // cdg_orientation
  geometry_msgs__msg__Vector3__fini(&msg->cdg_orientation);
  // lights
  // sirens
  // auxilary_lights
  // engine_state
  // consumption
  // pollution
  // engine_speed
  // gear_engaged
  // gas_pedal
  // brake_pedal
  // hand_brake
  // clutch_pedal
  // gear_box_mode
  // effective_ignition_key_position
  // is_engine_retarder
  // brake_retarder_notch
  // trailer_brake
  // transfer_choice
  // lock_diff_mode
  // force_lockup
  // plow_mode
  // steering_wheel_angle
  // steering_wheel_speed
  // steering_wheel_accel
  // steering_wheel_torque
  // hub_position
  for (size_t i = 0; i < 4; ++i) {
    geometry_msgs__msg__Point__fini(&msg->hub_position[i]);
  }
  // hub_orientation
  for (size_t i = 0; i < 4; ++i) {
    geometry_msgs__msg__Vector3__fini(&msg->hub_orientation[i]);
  }
  // wheel_rotation
  // wheel_rotation_speed
  // brake_temperature
  // abs_is_active
  // is_in_contact
  // contact_points
  for (size_t i = 0; i < 4; ++i) {
    geometry_msgs__msg__Point__fini(&msg->contact_points[i]);
  }
  // ground_normals
  for (size_t i = 0; i < 4; ++i) {
    geometry_msgs__msg__Vector3__fini(&msg->ground_normals[i]);
  }
  // grip
  // ground_index
  // lsr
  // slip_angle
  // tire_force
  for (size_t i = 0; i < 4; ++i) {
    geometry_msgs__msg__Vector3__fini(&msg->tire_force[i]);
  }
  // lane_type
  // roughness_height
  // roughness_length
  // roughness_height_stddev
  // roughness_length_stddev
  // ground_type
  // water_height
  // custom_output
}

bool
vrxperience_msgs__msg__VehicleOutput__are_equal(const vrxperience_msgs__msg__VehicleOutput * lhs, const vrxperience_msgs__msg__VehicleOutput * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__are_equal(
      &(lhs->header), &(rhs->header)))
  {
    return false;
  }
  // cdg_speed
  if (!geometry_msgs__msg__Vector3__are_equal(
      &(lhs->cdg_speed), &(rhs->cdg_speed)))
  {
    return false;
  }
  // cdg_angular_speed
  if (!geometry_msgs__msg__Vector3__are_equal(
      &(lhs->cdg_angular_speed), &(rhs->cdg_angular_speed)))
  {
    return false;
  }
  // cdg_accel
  if (!geometry_msgs__msg__Vector3__are_equal(
      &(lhs->cdg_accel), &(rhs->cdg_accel)))
  {
    return false;
  }
  // cdg_angular_accel
  if (!geometry_msgs__msg__Vector3__are_equal(
      &(lhs->cdg_angular_accel), &(rhs->cdg_angular_accel)))
  {
    return false;
  }
  // cdg_position
  if (!geometry_msgs__msg__Vector3__are_equal(
      &(lhs->cdg_position), &(rhs->cdg_position)))
  {
    return false;
  }
  // cdg_orientation
  if (!geometry_msgs__msg__Vector3__are_equal(
      &(lhs->cdg_orientation), &(rhs->cdg_orientation)))
  {
    return false;
  }
  // lights
  if (lhs->lights != rhs->lights) {
    return false;
  }
  // sirens
  if (lhs->sirens != rhs->sirens) {
    return false;
  }
  // auxilary_lights
  if (lhs->auxilary_lights != rhs->auxilary_lights) {
    return false;
  }
  // engine_state
  if (lhs->engine_state != rhs->engine_state) {
    return false;
  }
  // consumption
  if (lhs->consumption != rhs->consumption) {
    return false;
  }
  // pollution
  if (lhs->pollution != rhs->pollution) {
    return false;
  }
  // engine_speed
  if (lhs->engine_speed != rhs->engine_speed) {
    return false;
  }
  // gear_engaged
  if (lhs->gear_engaged != rhs->gear_engaged) {
    return false;
  }
  // gas_pedal
  if (lhs->gas_pedal != rhs->gas_pedal) {
    return false;
  }
  // brake_pedal
  if (lhs->brake_pedal != rhs->brake_pedal) {
    return false;
  }
  // hand_brake
  if (lhs->hand_brake != rhs->hand_brake) {
    return false;
  }
  // clutch_pedal
  if (lhs->clutch_pedal != rhs->clutch_pedal) {
    return false;
  }
  // gear_box_mode
  if (lhs->gear_box_mode != rhs->gear_box_mode) {
    return false;
  }
  // effective_ignition_key_position
  if (lhs->effective_ignition_key_position != rhs->effective_ignition_key_position) {
    return false;
  }
  // is_engine_retarder
  if (lhs->is_engine_retarder != rhs->is_engine_retarder) {
    return false;
  }
  // brake_retarder_notch
  if (lhs->brake_retarder_notch != rhs->brake_retarder_notch) {
    return false;
  }
  // trailer_brake
  if (lhs->trailer_brake != rhs->trailer_brake) {
    return false;
  }
  // transfer_choice
  if (lhs->transfer_choice != rhs->transfer_choice) {
    return false;
  }
  // lock_diff_mode
  if (lhs->lock_diff_mode != rhs->lock_diff_mode) {
    return false;
  }
  // force_lockup
  if (lhs->force_lockup != rhs->force_lockup) {
    return false;
  }
  // plow_mode
  if (lhs->plow_mode != rhs->plow_mode) {
    return false;
  }
  // steering_wheel_angle
  if (lhs->steering_wheel_angle != rhs->steering_wheel_angle) {
    return false;
  }
  // steering_wheel_speed
  if (lhs->steering_wheel_speed != rhs->steering_wheel_speed) {
    return false;
  }
  // steering_wheel_accel
  if (lhs->steering_wheel_accel != rhs->steering_wheel_accel) {
    return false;
  }
  // steering_wheel_torque
  if (lhs->steering_wheel_torque != rhs->steering_wheel_torque) {
    return false;
  }
  // hub_position
  for (size_t i = 0; i < 4; ++i) {
    if (!geometry_msgs__msg__Point__are_equal(
        &(lhs->hub_position[i]), &(rhs->hub_position[i])))
    {
      return false;
    }
  }
  // hub_orientation
  for (size_t i = 0; i < 4; ++i) {
    if (!geometry_msgs__msg__Vector3__are_equal(
        &(lhs->hub_orientation[i]), &(rhs->hub_orientation[i])))
    {
      return false;
    }
  }
  // wheel_rotation
  for (size_t i = 0; i < 4; ++i) {
    if (lhs->wheel_rotation[i] != rhs->wheel_rotation[i]) {
      return false;
    }
  }
  // wheel_rotation_speed
  for (size_t i = 0; i < 4; ++i) {
    if (lhs->wheel_rotation_speed[i] != rhs->wheel_rotation_speed[i]) {
      return false;
    }
  }
  // brake_temperature
  for (size_t i = 0; i < 4; ++i) {
    if (lhs->brake_temperature[i] != rhs->brake_temperature[i]) {
      return false;
    }
  }
  // abs_is_active
  for (size_t i = 0; i < 4; ++i) {
    if (lhs->abs_is_active[i] != rhs->abs_is_active[i]) {
      return false;
    }
  }
  // is_in_contact
  for (size_t i = 0; i < 4; ++i) {
    if (lhs->is_in_contact[i] != rhs->is_in_contact[i]) {
      return false;
    }
  }
  // contact_points
  for (size_t i = 0; i < 4; ++i) {
    if (!geometry_msgs__msg__Point__are_equal(
        &(lhs->contact_points[i]), &(rhs->contact_points[i])))
    {
      return false;
    }
  }
  // ground_normals
  for (size_t i = 0; i < 4; ++i) {
    if (!geometry_msgs__msg__Vector3__are_equal(
        &(lhs->ground_normals[i]), &(rhs->ground_normals[i])))
    {
      return false;
    }
  }
  // grip
  for (size_t i = 0; i < 4; ++i) {
    if (lhs->grip[i] != rhs->grip[i]) {
      return false;
    }
  }
  // ground_index
  for (size_t i = 0; i < 4; ++i) {
    if (lhs->ground_index[i] != rhs->ground_index[i]) {
      return false;
    }
  }
  // lsr
  for (size_t i = 0; i < 4; ++i) {
    if (lhs->lsr[i] != rhs->lsr[i]) {
      return false;
    }
  }
  // slip_angle
  for (size_t i = 0; i < 4; ++i) {
    if (lhs->slip_angle[i] != rhs->slip_angle[i]) {
      return false;
    }
  }
  // tire_force
  for (size_t i = 0; i < 4; ++i) {
    if (!geometry_msgs__msg__Vector3__are_equal(
        &(lhs->tire_force[i]), &(rhs->tire_force[i])))
    {
      return false;
    }
  }
  // lane_type
  for (size_t i = 0; i < 4; ++i) {
    if (lhs->lane_type[i] != rhs->lane_type[i]) {
      return false;
    }
  }
  // roughness_height
  for (size_t i = 0; i < 4; ++i) {
    if (lhs->roughness_height[i] != rhs->roughness_height[i]) {
      return false;
    }
  }
  // roughness_length
  for (size_t i = 0; i < 4; ++i) {
    if (lhs->roughness_length[i] != rhs->roughness_length[i]) {
      return false;
    }
  }
  // roughness_height_stddev
  for (size_t i = 0; i < 4; ++i) {
    if (lhs->roughness_height_stddev[i] != rhs->roughness_height_stddev[i]) {
      return false;
    }
  }
  // roughness_length_stddev
  for (size_t i = 0; i < 4; ++i) {
    if (lhs->roughness_length_stddev[i] != rhs->roughness_length_stddev[i]) {
      return false;
    }
  }
  // ground_type
  for (size_t i = 0; i < 4; ++i) {
    if (lhs->ground_type[i] != rhs->ground_type[i]) {
      return false;
    }
  }
  // water_height
  for (size_t i = 0; i < 4; ++i) {
    if (lhs->water_height[i] != rhs->water_height[i]) {
      return false;
    }
  }
  // custom_output
  for (size_t i = 0; i < 512; ++i) {
    if (lhs->custom_output[i] != rhs->custom_output[i]) {
      return false;
    }
  }
  return true;
}

bool
vrxperience_msgs__msg__VehicleOutput__copy(
  const vrxperience_msgs__msg__VehicleOutput * input,
  vrxperience_msgs__msg__VehicleOutput * output)
{
  if (!input || !output) {
    return false;
  }
  // header
  if (!std_msgs__msg__Header__copy(
      &(input->header), &(output->header)))
  {
    return false;
  }
  // cdg_speed
  if (!geometry_msgs__msg__Vector3__copy(
      &(input->cdg_speed), &(output->cdg_speed)))
  {
    return false;
  }
  // cdg_angular_speed
  if (!geometry_msgs__msg__Vector3__copy(
      &(input->cdg_angular_speed), &(output->cdg_angular_speed)))
  {
    return false;
  }
  // cdg_accel
  if (!geometry_msgs__msg__Vector3__copy(
      &(input->cdg_accel), &(output->cdg_accel)))
  {
    return false;
  }
  // cdg_angular_accel
  if (!geometry_msgs__msg__Vector3__copy(
      &(input->cdg_angular_accel), &(output->cdg_angular_accel)))
  {
    return false;
  }
  // cdg_position
  if (!geometry_msgs__msg__Vector3__copy(
      &(input->cdg_position), &(output->cdg_position)))
  {
    return false;
  }
  // cdg_orientation
  if (!geometry_msgs__msg__Vector3__copy(
      &(input->cdg_orientation), &(output->cdg_orientation)))
  {
    return false;
  }
  // lights
  output->lights = input->lights;
  // sirens
  output->sirens = input->sirens;
  // auxilary_lights
  output->auxilary_lights = input->auxilary_lights;
  // engine_state
  output->engine_state = input->engine_state;
  // consumption
  output->consumption = input->consumption;
  // pollution
  output->pollution = input->pollution;
  // engine_speed
  output->engine_speed = input->engine_speed;
  // gear_engaged
  output->gear_engaged = input->gear_engaged;
  // gas_pedal
  output->gas_pedal = input->gas_pedal;
  // brake_pedal
  output->brake_pedal = input->brake_pedal;
  // hand_brake
  output->hand_brake = input->hand_brake;
  // clutch_pedal
  output->clutch_pedal = input->clutch_pedal;
  // gear_box_mode
  output->gear_box_mode = input->gear_box_mode;
  // effective_ignition_key_position
  output->effective_ignition_key_position = input->effective_ignition_key_position;
  // is_engine_retarder
  output->is_engine_retarder = input->is_engine_retarder;
  // brake_retarder_notch
  output->brake_retarder_notch = input->brake_retarder_notch;
  // trailer_brake
  output->trailer_brake = input->trailer_brake;
  // transfer_choice
  output->transfer_choice = input->transfer_choice;
  // lock_diff_mode
  output->lock_diff_mode = input->lock_diff_mode;
  // force_lockup
  output->force_lockup = input->force_lockup;
  // plow_mode
  output->plow_mode = input->plow_mode;
  // steering_wheel_angle
  output->steering_wheel_angle = input->steering_wheel_angle;
  // steering_wheel_speed
  output->steering_wheel_speed = input->steering_wheel_speed;
  // steering_wheel_accel
  output->steering_wheel_accel = input->steering_wheel_accel;
  // steering_wheel_torque
  output->steering_wheel_torque = input->steering_wheel_torque;
  // hub_position
  for (size_t i = 0; i < 4; ++i) {
    if (!geometry_msgs__msg__Point__copy(
        &(input->hub_position[i]), &(output->hub_position[i])))
    {
      return false;
    }
  }
  // hub_orientation
  for (size_t i = 0; i < 4; ++i) {
    if (!geometry_msgs__msg__Vector3__copy(
        &(input->hub_orientation[i]), &(output->hub_orientation[i])))
    {
      return false;
    }
  }
  // wheel_rotation
  for (size_t i = 0; i < 4; ++i) {
    output->wheel_rotation[i] = input->wheel_rotation[i];
  }
  // wheel_rotation_speed
  for (size_t i = 0; i < 4; ++i) {
    output->wheel_rotation_speed[i] = input->wheel_rotation_speed[i];
  }
  // brake_temperature
  for (size_t i = 0; i < 4; ++i) {
    output->brake_temperature[i] = input->brake_temperature[i];
  }
  // abs_is_active
  for (size_t i = 0; i < 4; ++i) {
    output->abs_is_active[i] = input->abs_is_active[i];
  }
  // is_in_contact
  for (size_t i = 0; i < 4; ++i) {
    output->is_in_contact[i] = input->is_in_contact[i];
  }
  // contact_points
  for (size_t i = 0; i < 4; ++i) {
    if (!geometry_msgs__msg__Point__copy(
        &(input->contact_points[i]), &(output->contact_points[i])))
    {
      return false;
    }
  }
  // ground_normals
  for (size_t i = 0; i < 4; ++i) {
    if (!geometry_msgs__msg__Vector3__copy(
        &(input->ground_normals[i]), &(output->ground_normals[i])))
    {
      return false;
    }
  }
  // grip
  for (size_t i = 0; i < 4; ++i) {
    output->grip[i] = input->grip[i];
  }
  // ground_index
  for (size_t i = 0; i < 4; ++i) {
    output->ground_index[i] = input->ground_index[i];
  }
  // lsr
  for (size_t i = 0; i < 4; ++i) {
    output->lsr[i] = input->lsr[i];
  }
  // slip_angle
  for (size_t i = 0; i < 4; ++i) {
    output->slip_angle[i] = input->slip_angle[i];
  }
  // tire_force
  for (size_t i = 0; i < 4; ++i) {
    if (!geometry_msgs__msg__Vector3__copy(
        &(input->tire_force[i]), &(output->tire_force[i])))
    {
      return false;
    }
  }
  // lane_type
  for (size_t i = 0; i < 4; ++i) {
    output->lane_type[i] = input->lane_type[i];
  }
  // roughness_height
  for (size_t i = 0; i < 4; ++i) {
    output->roughness_height[i] = input->roughness_height[i];
  }
  // roughness_length
  for (size_t i = 0; i < 4; ++i) {
    output->roughness_length[i] = input->roughness_length[i];
  }
  // roughness_height_stddev
  for (size_t i = 0; i < 4; ++i) {
    output->roughness_height_stddev[i] = input->roughness_height_stddev[i];
  }
  // roughness_length_stddev
  for (size_t i = 0; i < 4; ++i) {
    output->roughness_length_stddev[i] = input->roughness_length_stddev[i];
  }
  // ground_type
  for (size_t i = 0; i < 4; ++i) {
    output->ground_type[i] = input->ground_type[i];
  }
  // water_height
  for (size_t i = 0; i < 4; ++i) {
    output->water_height[i] = input->water_height[i];
  }
  // custom_output
  for (size_t i = 0; i < 512; ++i) {
    output->custom_output[i] = input->custom_output[i];
  }
  return true;
}

vrxperience_msgs__msg__VehicleOutput *
vrxperience_msgs__msg__VehicleOutput__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  vrxperience_msgs__msg__VehicleOutput * msg = (vrxperience_msgs__msg__VehicleOutput *)allocator.allocate(sizeof(vrxperience_msgs__msg__VehicleOutput), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(vrxperience_msgs__msg__VehicleOutput));
  bool success = vrxperience_msgs__msg__VehicleOutput__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
vrxperience_msgs__msg__VehicleOutput__destroy(vrxperience_msgs__msg__VehicleOutput * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    vrxperience_msgs__msg__VehicleOutput__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
vrxperience_msgs__msg__VehicleOutput__Sequence__init(vrxperience_msgs__msg__VehicleOutput__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  vrxperience_msgs__msg__VehicleOutput * data = NULL;

  if (size) {
    data = (vrxperience_msgs__msg__VehicleOutput *)allocator.zero_allocate(size, sizeof(vrxperience_msgs__msg__VehicleOutput), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = vrxperience_msgs__msg__VehicleOutput__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        vrxperience_msgs__msg__VehicleOutput__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
vrxperience_msgs__msg__VehicleOutput__Sequence__fini(vrxperience_msgs__msg__VehicleOutput__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      vrxperience_msgs__msg__VehicleOutput__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

vrxperience_msgs__msg__VehicleOutput__Sequence *
vrxperience_msgs__msg__VehicleOutput__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  vrxperience_msgs__msg__VehicleOutput__Sequence * array = (vrxperience_msgs__msg__VehicleOutput__Sequence *)allocator.allocate(sizeof(vrxperience_msgs__msg__VehicleOutput__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = vrxperience_msgs__msg__VehicleOutput__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
vrxperience_msgs__msg__VehicleOutput__Sequence__destroy(vrxperience_msgs__msg__VehicleOutput__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    vrxperience_msgs__msg__VehicleOutput__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
vrxperience_msgs__msg__VehicleOutput__Sequence__are_equal(const vrxperience_msgs__msg__VehicleOutput__Sequence * lhs, const vrxperience_msgs__msg__VehicleOutput__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!vrxperience_msgs__msg__VehicleOutput__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
vrxperience_msgs__msg__VehicleOutput__Sequence__copy(
  const vrxperience_msgs__msg__VehicleOutput__Sequence * input,
  vrxperience_msgs__msg__VehicleOutput__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(vrxperience_msgs__msg__VehicleOutput);
    vrxperience_msgs__msg__VehicleOutput * data =
      (vrxperience_msgs__msg__VehicleOutput *)realloc(output->data, allocation_size);
    if (!data) {
      return false;
    }
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!vrxperience_msgs__msg__VehicleOutput__init(&data[i])) {
        /* free currently allocated and return false */
        for (; i-- > output->capacity; ) {
          vrxperience_msgs__msg__VehicleOutput__fini(&data[i]);
        }
        free(data);
        return false;
      }
    }
    output->data = data;
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!vrxperience_msgs__msg__VehicleOutput__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
